var reliby = {

	_console: false,

	init: function() {
	},

	reloadLiveBookmarks: function() {
		var reloaded = false;
		var cc;
		try {
			this.trace("Try to reload all livemarks using service 1");
			cc = Components.classes["@mozilla.org/browser/livemark-service;1"];
			var livemarks = cc.getService(Components.interfaces.nsILivemarkService);
			livemarks.reloadAllLivemarks();
			reloaded = true;
			var txt = document.getElementById("bundle_reliby").getString("reloadAll.label");
			this.updateStatusbar(txt);
		} catch(ex) {
			this.trace(ex);
			try {
				this.trace("Try to reload all livemarks using service 2");
				cc = Components.classes["@mozilla.org/browser/livemark-service;2"];
				var livemarks = cc.getService(Components.interfaces.nsILivemarkService);
				livemarks.reloadAllLivemarks();
				reloaded = true;
				var txt = document.getElementById("bundle_reliby").getString("reloadAll.label");
				this.updateStatusbar(txt);
			} catch(ex) {
				this.trace(ex);
			}
		}

		if (!reloaded) {
			this.trace("Try to reload livemarks one by one");
			var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
			var bmds;
			try {
				bmds = rdf.GetDataSource("rdf:bookmarks");
			} catch(ex) {
				this.trace("Unable to get bookmarks datasource");
			}
			if (bmds) {
				var nameArc = rdf.GetResource("http://home.netscape.com/NC-rdf#Name");
				var feedArc = rdf.GetResource("http://home.netscape.com/NC-rdf#FeedURL");
				var feedExp = rdf.GetResource("http://home.netscape.com/NC-rdf#LivemarkExpiration");
				var iter = bmds.GetAllResources();
				var num_to = 0;
				var num_ok = 0;
				while (iter.hasMoreElements()) {
					try {
						var element = iter.getNext();
						element.QueryInterface(Components.interfaces.nsIRDFResource);
						var target = bmds.GetTarget(element, nameArc, true);
						if (target == null)
							continue;
						var name = target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
						target = bmds.GetTarget(element, feedArc, true);
						if (target == null)
							continue;
						var url = target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
						var rsrc = rdf.GetResource(element.Value);
						target = bmds.GetTarget(rsrc, feedExp, true);
						num_to++;
						if (target) {
							bmds.Unassert(rsrc, feedExp, target);
							this.trace("Reloading: " + url);
							num_ok++;
						} else {
							this.trace("Live bookmark is not loaded yet or unable to reload: " + url);
						}
					} catch(ex) {
						this.trace("Error: " + ex);
					}
				}
				this.trace("Number of livemarks: " + num_to);
				if (num_to) {
					var txt = document.getElementById("bundle_reliby").getString("reloadSome.label");
					txt = this.replaceInsert(txt, 1, num_ok);
					txt = this.replaceInsert(txt, 2, num_to);
					this.updateStatusbar(txt);
				}
			}
		}
	},

	replaceInsert: function(aTxt, aNumber, aTxtReplace) {
		var result = aTxt;
		if (result) {
			var re = new RegExp("#" + aNumber, "g");
			result = result.replace(re, aTxtReplace);
		}
		return result;
	},

	updateStatusbar: function(aTxt) {
		this.trace(aTxt);
		var stat = document.getElementById("statusbar-display");
		if (stat)
			stat.label = "reliby: " + aTxt;
	},

	trace: function(aMsg) {
		if (!this._console) {
			this._console = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
		}
		this._console.logStringMessage("reliby: " + aMsg);
	}

};

window.addEventListener("load", function(e) {reliby.init(e)}, false);
